> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tokenfactory.nebius.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a dataset by uploading data

> Create a dataset



## OpenAPI

````yaml https://api.tokenfactory.nebius.com/openapi.json post /v1/datasets
openapi: 3.1.0
info:
  title: Nebius OpenAI-compatible inference API
  version: 20260506-297d05704
servers:
  - url: https://api.tokenfactory.nebius.com
security: []
paths:
  /v1/datasets:
    post:
      tags:
        - datasets
      summary: Create a dataset by uploading data
      description: Create a dataset
      operationId: create_dataset_v1_datasets_post
      requestBody:
        required: true
        content:
          application/json:
            schema:
              anyOf:
                - $ref: '#/components/schemas/CreateDatasetRequestUpload'
                - $ref: '#/components/schemas/CreateDatasetRequestS3'
              title: Request
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateDatasetResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    CreateDatasetRequestUpload:
      properties:
        name:
          type: string
          title: Name
          description: ID of the dataset.
          examples:
            - example_dataset
        schema:
          items:
            $ref: '#/components/schemas/ColumnSchema-Input'
          type: array
          title: Schema
          description: Dataset schema definition.
          examples:
            - name: text
              type:
                name: string
            - name: text_1
              type:
                item:
                  name: string
                name: option
        folder:
          type: string
          title: Folder
          description: Folder path where the dataset is stored.
          examples:
            - /some/folder
        rows:
          items:
            type: object
          type: array
          title: Rows
          description: List of rows to be included in the dataset.
          examples:
            - text: This is the first row.
        ai_project_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Ai Project Id
          description: AI Studio project ID to associate with the dataset.
          examples:
            - example_project
      type: object
      required:
        - name
        - schema
        - folder
        - rows
      title: CreateDatasetRequestUpload
    CreateDatasetRequestS3:
      properties:
        name:
          type: string
          title: Name
          description: ID of the dataset.
          examples:
            - example_dataset
        folder:
          type: string
          title: Folder
          description: Folder path where the dataset is stored.
          examples:
            - /some/folder
        s3_service_url:
          type: string
          title: S3 Service Url
          description: S3 URL to import dataset from.
          examples:
            - https://storage.eu-north1.nebius.cloud:443
        s3_region:
          type: string
          title: S3 Region
          description: Region of the S3 bucket.
          examples:
            - eu-north-1
        s3_uri:
          type: string
          title: S3 Uri
          description: S3 URI to import dataset from.
          examples:
            - s3://my-bucket/path/to/dataset.csv
        s3_key_id:
          type: string
          title: S3 Key Id
          description: Secret key id for the S3 bucket.
          examples:
            - AKIAIOSFODNN7EXAMPLE
        s3_secret_key:
          type: string
          title: S3 Secret Key
          description: Secret key for the S3 bucket.
          examples:
            - some_key
        ai_project_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Ai Project Id
          description: AI Studio project ID to associate with the dataset.
          examples:
            - example_project
      type: object
      required:
        - name
        - folder
        - s3_service_url
        - s3_region
        - s3_uri
        - s3_key_id
        - s3_secret_key
      title: CreateDatasetRequestS3
    CreateDatasetResponse:
      properties:
        id:
          type: string
          title: Id
          description: The object identifier, which can be referenced in the API endpoints.
          examples:
            - 4d89c87498354518b92fa02fc0ad8720
        name:
          type: string
          title: Name
          description: ID of the dataset.
          examples:
            - example_dataset
        status:
          allOf:
            - $ref: '#/components/schemas/DatasetStatus'
          description: Current status of the dataset.
          examples:
            - READY
            - FAILED
            - PENDING
        schema:
          items:
            $ref: '#/components/schemas/ColumnSchema-Output'
          type: array
          title: Schema
          description: Dataset schema definition.
          examples:
            - name: text
              type:
                name: string
            - name: text_1
              type:
                item:
                  name: string
                name: option
        metadata:
          additionalProperties:
            anyOf:
              - type: string
              - items:
                  type: string
                type: array
          type: object
          title: Metadata
          description: Additional metadata associated with the dataset.
          examples:
            - {}
        current_version_origin:
          anyOf:
            - $ref: '#/components/schemas/DatasetOriginResponse'
            - type: 'null'
          description: >-
            Origin information for the current dataset version. This object is
            extensible for source-specific fields.
          examples:
            - type: s3
        folder:
          type: string
          title: Folder
          description: Folder path where the dataset is stored.
          examples:
            - /some/folder
        current_version:
          type: string
          title: Current Version
          description: Current version of the dataset.
          examples:
            - 0ed2d94b38fb40b9b61f6a
        created_at:
          type: integer
          title: Created At
          description: Unix timestamp when the dataset was created.
          examples:
            - 1760109124
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
          description: Error message if the dataset is in an error state.
        ai_project_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Ai Project Id
          description: AI Studio project ID to associate with the dataset.
          examples:
            - example_project
      type: object
      required:
        - id
        - name
        - status
        - schema
        - metadata
        - folder
        - current_version
        - created_at
        - error
      title: CreateDatasetResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ColumnSchema-Input:
      properties:
        name:
          type: string
          title: Name
        type:
          anyOf:
            - $ref: '#/components/schemas/SchemaPrimitive'
            - $ref: '#/components/schemas/SchemaOption-Input'
          title: Type
      type: object
      required:
        - name
        - type
      title: ColumnSchema
    DatasetStatus:
      type: string
      enum:
        - READY
        - PENDING
        - FAILED
        - TEMPORARY
        - DRAFT
      title: DatasetStatus
    ColumnSchema-Output:
      properties:
        name:
          type: string
          title: Name
        type:
          anyOf:
            - $ref: '#/components/schemas/SchemaPrimitive'
            - $ref: '#/components/schemas/SchemaOption-Output'
          title: Type
      type: object
      required:
        - name
        - type
      title: ColumnSchema
    DatasetOriginResponse:
      properties:
        type:
          allOf:
            - $ref: '#/components/schemas/DatasetOriginType'
          description: How the current dataset version was produced.
          examples:
            - s3
      type: object
      required:
        - type
      title: DatasetOriginResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    SchemaPrimitive:
      properties:
        name:
          $ref: '#/components/schemas/SchemaPrimitiveType'
      type: object
      required:
        - name
      title: SchemaPrimitive
    SchemaOption-Input:
      properties:
        name:
          $ref: '#/components/schemas/SchemaOptionType'
        item:
          anyOf:
            - $ref: '#/components/schemas/SchemaPrimitive'
            - $ref: '#/components/schemas/SchemaOption-Input'
          title: Item
      type: object
      required:
        - name
        - item
      title: SchemaOption
    SchemaOption-Output:
      properties:
        name:
          $ref: '#/components/schemas/SchemaOptionType'
        item:
          anyOf:
            - $ref: '#/components/schemas/SchemaPrimitive'
            - $ref: '#/components/schemas/SchemaOption-Output'
          title: Item
      type: object
      required:
        - name
        - item
      title: SchemaOption
    DatasetOriginType:
      type: string
      enum:
        - upload
        - s3
      title: DatasetOriginType
    SchemaPrimitiveType:
      type: string
      enum:
        - string
        - integer
        - boolean
        - float
        - double
        - json
        - 'null'
      title: SchemaPrimitiveType
    SchemaOptionType:
      type: string
      enum:
        - option
      const: option
      title: SchemaOptionType
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````